﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using Notes.com.bullhornstaffing.api;

namespace Notes
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            String username = "yourusername";
            String password = "yourpassword";
            String apiKey = "yourapikey";

            ApiService service = new ApiService();

            apiSession currentSession = new apiSession();

            // Start an API session
            currentSession = service.startSession(username, password, apiKey);

            DateTime jobdate = DateTime.Now;

            // Query a specific candidate to link to a note, change this based on your account
            dtoQuery candidateQuery = new dtoQuery();
            candidateQuery.entityName = "Candidate";
            candidateQuery.maxResults = 10;
            candidateQuery.where = "FirstName = 'Delvan'";
            apiQueryResult queryCandidateResult = service.query(currentSession, candidateQuery);
            currentSession = queryCandidateResult.session;

            foreach (int i in queryCandidateResult.ids)
            {
                apiFindResult candidate = service.find(currentSession, "Candidate", i);
                currentSession = candidate.session;
                candidateDto thisCandidate = (candidateDto)candidate.dto;

                // Create a new note
                noteDto noteDto = new noteDto();
                noteDto.commentingPersonID = currentSession.userId;
                noteDto.commentingPersonIDSpecified = true;
                noteDto.comments = "This is the note being linked to a candidate.";
                noteDto.dateAdded = jobdate;
                noteDto.dateAddedSpecified = true;
                noteDto.isDeleted = false;
                noteDto.isDeletedSpecified = true;
                noteDto.personReferenceID = thisCandidate.userID;
                noteDto.personReferenceIDSpecified = true;

                apiSaveResult results = service.save(currentSession, noteDto);
                currentSession = results.session;

                noteDto SavedNoteDto = (noteDto)results.dto;

                // Associate the note with a candidate
                service.addNoteReference(currentSession, SavedNoteDto.noteID, "Candidate", thisCandidate.userID);


                // Query a job t o link to a note, change this based on your account
                dtoQuery jobQuery = new dtoQuery();
                jobQuery.entityName = "JobOrder";
                jobQuery.maxResults = 20;
                jobQuery.where = "isOpen = 1";
                apiQueryResult queryResult = service.query(currentSession, jobQuery);
                currentSession = queryResult.session;

                foreach (int j in queryResult.ids)
                {
                    apiFindResult jobOrder = service.find(currentSession, "JobOrder", j);
                    currentSession = jobOrder.session;
                    jobOrderDto thisJobOrder = (jobOrderDto)jobOrder.dto;

                    // Associate the note with a job order
                    service.addNoteReference(currentSession, SavedNoteDto.noteID, "JobOrder", thisJobOrder.jobOrderID);
                }

                // Retrieve the client contact id before running this. It is hard coded here, change this based on your account
                // Associate the note with a client contact
                service.addNoteReference(currentSession, SavedNoteDto.noteID, "ClientContact", 6600);

            }

            // Candidate ID is hard coded here, change this based on your account
            apiGetEntityNotesResult resultNotes = service.getEntityNotes(currentSession, "Candidate", 6521);
            // Refresh the session
            currentSession = resultNotes.session;

            foreach (int i in resultNotes.ids)
            {
                apiFindResult findNoteResult = service.find(currentSession, "Note", i);

                // Refresh the session
                currentSession = findNoteResult.session;
                noteDto thisNote = (noteDto)findNoteResult.dto;
                // Run the debugger to see the note instance and the properties on it.
            }

            // Candidate ID is hard coded here, change this based on your account
            apiGetEntityNotesResult resultNotes1 = service.getEntityNotesWhere(currentSession, "Candidate", 6521, "note.action = 'sample'");
            // Refresh the session
            currentSession = resultNotes.session;

            foreach (int i in resultNotes.ids)
            {
                apiFindResult findNoteResult = service.find(currentSession, "Note", i);

                // Refresh the session
                currentSession = findNoteResult.session;
                noteDto thisNote = (noteDto)findNoteResult.dto;
                // Run the debugger to see the note instance and the properties on it.
            }
        }
    }
}

